<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import {
  type OwnershipTransferRequestOut,
  OwnershipTypeEnum,
} from "@/client/types.gen";
import OtrModal from "@/components/modals/ShowOtrModal.vue";
import { ref } from "vue";
import dayjs from "dayjs";
import { useNameStore } from "@/stores/names";

const nameRepo = useNameStore();

const props = defineProps<{
  modalId: string;
  otrType: OwnershipTypeEnum;
  otrs: OwnershipTransferRequestOut[];
}>();

const otrTargetId = ref<string>("");

const randomIDSuffix = Math.random().toString(16).substring(2, 8);
</script>

<template>
  <otr-modal
    :otr-target-id="otrTargetId"
    :modal-id="`view-bucket-otr-modal-${randomIDSuffix}`"
    :back-modal-id="modalId"
  />
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    size-modifier-modal="lg"
    :modal-label="`List ${props.otrType} OTRs`"
  >
    <template #header
      >Ownership transfer requests for {{ props.otrType }}s
    </template>
    <template #body>
      <div v-if="otrs.length > 0">
        <div class="d-flex justify-content-between w-100 px-3 py-2">
          <span>Name</span>
          <span>Current Owner</span>
          <span>Requested at</span>
        </div>
        <div class="list-group">
          <button
            v-for="otr of otrs"
            :key="otr.target_id"
            type="button"
            class="list-group-item list-group-item-action d-flex justify-content-between"
            :data-bs-target="`#view-bucket-otr-modal-${randomIDSuffix}`"
            data-bs-toggle="modal"
            @click="otrTargetId = otr.target_id"
          >
            <span>{{ otr.target_name }}</span>
            <span v-if="otr.current_owner_uid">{{
              nameRepo.getName(otr.current_owner_uid)
            }}</span>
            <span>{{ dayjs.unix(otr.created_at).fromNow() }}</span>
          </button>
        </div>
      </div>
      <div v-else>
        <h3 class="text-center">
          No open {{ props.otrType }} ownership transfer requests
        </h3>
      </div>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
